
  <!DOCTYPE html>
  <html>
    <head>
      <title>Graphic.tsx</title>
      <link href="https://cdn.jsdelivr.net/npm/semantic-ui@2.4.2/dist/semantic.min.css" type="text/css" rel="stylesheet">
      <script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.js" type="text/javascript" charset="utf-8"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/mode/javascript/javascript.min.js" type="text/javascript" charset="utf-8"></script>
<link href="https://cdnjs.cloudflare.com/ajax/libs/codemirror/5.58.2/codemirror.min.css" type="text/css" rel="stylesheet">
<script src="../../../../assets/source-file.js" type="text/javascript" charset="utf-8"></script>
<link href="../../../../assets/source-file.css" type="text/css" rel="stylesheet">
    </head>
    <body>
    <div style="margin-top:3em" class="ui container"><h1 class="ui header"><a href="../../../../index.html">TypeScript coverage report</a></h1><table style="margin-top:2em" class="ui celled table"><thead class=""><tr class=""><th class="">Filename</th><th class="">Percent</th><th class="">Threshold</th><th class="">Total</th><th class="">Covered</th><th class="">Uncovered</th></tr></thead><tbody class=""><tr class="positive"><td class="">src/components/Graphic/Graphic.tsx</td><td class="">98.95%</td><td class="">80%</td><td class="">287</td><td class="">284</td><td class="">3</td></tr></tbody></table><textarea id="editor" readonly="" style="margin-top:3em">import React, { useCallback, useEffect, useMemo, useState } from &#x27;react&#x27;;
import {
  CartesianGrid,
  LineChart,
  ResponsiveContainer,
  Tooltip
} from &#x27;recharts&#x27;;
import { DOT_CLICK_EVENT, EXCLUDED_COLOR, SELECTED_COLOR } from &#x27;./constants&#x27;;
import { useRenderCustomizedLine } from &#x27;./hooks/useRenderCustomizedLine&#x27;;
import { useRenderCustomizedYAxis } from &#x27;./hooks/useRenderCustomizedYAxis&#x27;;
import { useCustomizedTooltipWrapperProps } from &#x27;./hooks/useCustomizedTooltipWrapperProps&#x27;;
import { useRenderCustomizedXAxis } from &#x27;./hooks/useRenderCustomizedXAxis&#x27;;
import { useRenderReferenceDot } from &#x27;./hooks/useRenderReferenceDot&#x27;;

export type SelectedPoint&lt;Key extends string&gt; = {
  id: number;
  dataKey: Key;
  x: number | null;
  y: number | null;
};

export type InternalSelectedPoint&lt;Key extends string&gt; = SelectedPoint&lt;Key&gt; &amp; {
  cx?: number;
  cy?: number;
};
export interface GraphicLine&lt;Key extends string = string&gt; {
  name: string;
  dataKey: Key;
  stroke?: string;
  onlyLine?: boolean;
  onlyDots?: boolean;
}
export interface GraphicProps&lt;Key extends string = string&gt; {
  data: { [key in Key &amp; &#x27;id&#x27;]: number }[];
  xAxis: { label: string; dataKey: Key };
  yAxisUnit?: string;
  connectPointsByLines?: boolean;
  lines: GraphicLine&lt;Key&gt;[];
  children?: unknown;
  selectedPoint?: null | SelectedPoint&lt;Key&gt;;
  onSelectPoint?: (value: null | SelectedPoint&lt;Key&gt;) =&gt; void;
  selectedBatches?: Key[];
  onChangeSelectedBatches?: (value: Key[]) =&gt; void;
  excludedBatches?: Key[];
  onChangeExcludedBatches?: (value: Key[]) =&gt; void;
  selectedPoints?: SelectedPoint&lt;Key&gt;[];
  onChangeSelectedPoints?: (value: SelectedPoint&lt;Key&gt;[]) =&gt; void;
  excludedPoints?: SelectedPoint&lt;Key&gt;[];
  onChangeExcludedPoints?: (value: SelectedPoint&lt;Key&gt;[]) =&gt; void;
  renderTooltip: (value: SelectedPoint&lt;Key&gt;) =&gt; React.ReactNode;
  showIncludeExcludeControls?: boolean;
}

export const Graphic: React.FC&lt;GraphicProps&gt; = &lt;Key extends string&gt;({
  data,
  xAxis,
  yAxisUnit,
  selectedPoint: externalSelectedPoint,
  onSelectPoint,
  connectPointsByLines = true,
  showIncludeExcludeControls,
  lines,
  renderTooltip,
  excludedBatches = [],
  excludedPoints = [],
  onChangeExcludedBatches,
  onChangeExcludedPoints,
  selectedPoints = [],
  selectedBatches = [],
  onChangeSelectedPoints,
  onChangeSelectedBatches
}: GraphicProps&lt;Key&gt;) =&gt; {
  const [internalSelectedPoint, internalOnSelectPoint] =
    useState&lt;null | InternalSelectedPoint&lt;Key&gt;&gt;(externalSelectedPoint ?? null);
  const selectedPoint: InternalSelectedPoint&lt;Key&gt; | null | undefined = useMemo(
    () =&gt;
      internalSelectedPoint ??
      (externalSelectedPoint as InternalSelectedPoint&lt;Key&gt; | null | undefined),
    [externalSelectedPoint, internalSelectedPoint]
  );
  const handleSelectPoint = useCallback(
    (event: React.MouseEvent&lt;HTMLDivElement&gt;) =&gt; {
      const pointId = event.detail as unknown as InternalSelectedPoint&lt;Key&gt;;

      if (onSelectPoint) {
        onSelectPoint({
          x: pointId.x,
          y: pointId.y,
          dataKey: pointId.dataKey,
          id: pointId.id
        });
      }
      internalOnSelectPoint(pointId);
    },
    [onSelectPoint]
  );
  const onUnselectPoint = useCallback(() =&gt; {
    if (onSelectPoint) {
      onSelectPoint(null);
    }
    internalOnSelectPoint(null);
  }, [onSelectPoint]);
  const [rootRef, setRootRef] = useState&lt;HTMLDivElement | null&gt;(null);
  useEffect(() =&gt; {
    if (rootRef) {
      rootRef.addEventListener(DOT_CLICK_EVENT as any, handleSelectPoint);
      return () =&gt; {
        rootRef.removeEventListener(DOT_CLICK_EVENT as any, handleSelectPoint);
      };
    }
  }, [handleSelectPoint, rootRef]);

  const renderCustomizedXAxis = useRenderCustomizedXAxis(xAxis);
  const renderCustomizedYAxis = useRenderCustomizedYAxis(yAxisUnit);
  const renderReferenceDot = useRenderReferenceDot();
  const renderCustomizedLine = useRenderCustomizedLine({
    xAxisKey: xAxis.dataKey,
    connectPointsByLines
  });
  const tooltipProps = useCustomizedTooltipWrapperProps({
    excludedBatches,
    excludedPoints,
    onUnselectPoint,
    onChangeExcludedPoints,
    onChangeExcludedBatches,
    showIncludeExcludeControls,
    renderTooltip,
    selectedPoint,
    selectedPoints,
    selectedBatches,
    onChangeSelectedPoints,
    onChangeSelectedBatches
  });

  return (
    &lt;div style={{ height: &#x27;100%&#x27; }} ref={setRootRef}&gt;
      &lt;ResponsiveContainer width=&quot;100%&quot; height=&quot;100%&quot;&gt;
        &lt;LineChart data={data}&gt;
          &lt;CartesianGrid strokeDasharray=&quot;3 3&quot; /&gt;
          {renderCustomizedXAxis()}
          {renderCustomizedYAxis()}
          &lt;Tooltip {...tooltipProps} /&gt;
          {lines.map((line) =&gt;
            renderCustomizedLine({
              dataKey: line.dataKey,
              color: line.stroke,
              onlyLine: line.onlyLine,
              onlyDots: line.onlyDots
            })
          )}
          {selectedBatches.map((selectedBatch) =&gt;
            renderCustomizedLine({
              dataKey: selectedBatch,
              color: SELECTED_COLOR
            })
          )}
          {selectedPoints.map((selectedPoint) =&gt;
            renderReferenceDot({
              color: SELECTED_COLOR,
              point: selectedPoint
            })
          )}
          {selectedPoint &amp;&amp;
            renderReferenceDot({ color: SELECTED_COLOR, point: selectedPoint })}
          {excludedBatches.map((excludedBatch) =&gt;
            renderCustomizedLine({
              dataKey: excludedBatch,
              color: EXCLUDED_COLOR
            })
          )}
          {excludedPoints.map((excludedPoint) =&gt;
            renderReferenceDot({
              color: EXCLUDED_COLOR,
              point: excludedPoint
            })
          )}
        &lt;/LineChart&gt;
      &lt;/ResponsiveContainer&gt;
    &lt;/div&gt;
  );
};
</textarea><pre id="annotations" style="display:none">[{&quot;file&quot;:&quot;src/components/Graphic/Graphic.tsx&quot;,&quot;line&quot;:82,&quot;character&quot;:22,&quot;text&quot;:&quot;event.detail as unknown as InternalSelectedPoint&lt;Key&gt;&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/components/Graphic/Graphic.tsx&quot;,&quot;line&quot;:105,&quot;character&quot;:31,&quot;text&quot;:&quot;DOT_CLICK_EVENT as any&quot;,&quot;kind&quot;:3},{&quot;file&quot;:&quot;src/components/Graphic/Graphic.tsx&quot;,&quot;line&quot;:107,&quot;character&quot;:36,&quot;text&quot;:&quot;DOT_CLICK_EVENT as any&quot;,&quot;kind&quot;:3}]</pre></div>
    <p class="footer-text">TypeScript Coverage Report generated by <a href="https://github.com/plantain-00/type-coverage">type-coverage</a> and <a href="https://github.com/alexcanessa/typescript-coverage-report">typescript-coverage-report</a> at Tue, 05 Oct 2021 23:09:04 GMT</p>
    </body>
  </html>
  